#!/usr/bin/python
import re, sys, operator

def rnn_rerank( nbestfile, scoresfile ):
    nbest_results = []
    for result in open(nbestfile,"r"):
        index, hyp = result.strip().split("\t")
        index = int(index)
        nbest_results.append([index,hyp])

    for i,score in enumerate(open(scoresfile,"r")):
        if i==0: continue
        score = float(score.strip())
        nbest_results[i-1].append(score)
    
    nindex = 0
    tmparr = []
    for entry in nbest_results:
        if entry[0] == nindex:
            tmparr.append( [entry[1],entry[2]] )
        elif entry[0] == nindex+1:
           tmparr.sort(key=lambda x:x[1], reverse=True)
           for item in tmparr:
               phons = re.split(r"\s+",item[0])
               phons.pop(0); phons.pop(-1)
               phons = [ re.sub(r"^[^\}]*\}","", ph.replace("_","") ) for ph in phons ]
               titem = " ".join(phons)
               titem = re.sub(r"\s+"," ",titem)
               titem = titem.strip()
               if not titem=="":
                   print nindex, item[1], item[0]
           tmparr = []
           nindex += 1
           tmparr.append( [entry[1], entry[2]] )
    
    tmparr.sort(key=lambda x:x[1], reverse=True)
    for item in tmparr:
        phons = re.split(r"\s+",item[0])
        phons.pop(0); phons.pop(-1)
        phons = [ re.sub(r"^[^\}]*\}","", ph.replace("_","") ) for ph in phons ]
        titem = " ".join(phons)
        titem = re.sub(r"\s+"," ",titem)
        titem = titem.strip()
        if not titem=="":
            print nindex, item[1], item[0]

    return

def rnn_to_hyp( rnng2pfile ):
    entries = []
    for line in open(rnng2pfile,"r"):
        parts = re.split(r"\s+",line.strip())
        index = int(parts.pop(0))
        parts.pop(0); parts.pop(0); parts.pop(-1)
        pron = []
        word = []
        for unit in parts:
            graph, phon = unit.split("}")
            graph = graph.replace("|","")
            graph = graph.replace("_","")
            graph = re.sub(r"\s+","", graph)
            graph = graph.strip()
            if not graph=="":
                word.append(graph)

            phon = phon.replace("|"," ")
            phon = phon.replace("_","")
            phon = re.sub(r"\s+", " ", phon)
            phon = phon.strip()
        
            if not phon=="":
                pron.append(phon)
        if len(entries)==0:
            entries.append([index, "".join(word), " ".join(pron)])
        elif not index==entries[-1][0]:
            entries.append([index, "".join(word), " ".join(pron)])

    for entry in entries:
        print "%s\t0.0\t%s" % (entry[1], entry[2])
    return

if __name__=="__main__":
    import sys
    if len(sys.argv)==3:
        rnn_rerank( sys.argv[1], sys.argv[2] )
    elif len(sys.argv)==2:
        rnn_to_hyp( sys.argv[1] )
