#!/bin/bash

if [ $# -ne 1 ]
then
    echo "SYNTAX: $0 <prefix>"
    echo "  <prefix>: Should be the same as used for g2p model training."
    echo "            Will be used to generate the 'valid' and rnnlm model files."
    echo "EX: $0 nt5k/nt5k"
    exit 0
fi
prefix=${1}

echo "Generating validation data.  By default this will be a small subset of the training data."
echo "There is a slightly better way to setup the validation data to use all the training data"
echo "  but the authors said that this is not unreasonable for now."  
echo ""
./rand-subset.py ${prefix} 500

echo "Starting rnnlm training..."
echo "./rnnlm -train ${prefix}.corpus -rnnlm ${prefix}.rnnlm -hidden 300 -valid ${prefix}.valid -rand-seed 1 -debug 2 -class 1 -bptt 10 -bptt-block 10 -direct-order 4 -direct 2"
rnnlm-0.3c/rnnlm -train ${prefix}.corpus -rnnlm ${prefix}.rnnlm -hidden 150 -valid ${prefix}.valid -rand-seed 1 -debug 2 -class 50 -bptt 10 -bptt-block 10 -direct-order 4 -direct 2